package gui;
// CSE 331, Autumn 2011, Krysta Yousoufian
// Used with permission and slight modifications from Marty Stepp, CSE 331, Spring 2011
//
// This program displays a simple Graphical User Interface (GUI) to demonstrate
// the Java Swing library.
// It just pops up several buttons and lets us change their color when we
// click on them.

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class AdvancedGUI {
	// For anything less trivial than this demo, your buttons and panel should
	// have more descriptive names
	private JButton button1, button2;
	private JPanel panel;
	private JFrame frame;
	
	// Constructs the GUI and displays it on the screen.
	// This is pretty long for a constructor. In a real application, you'd want
	// to group it into several self-contained sections (e.g. create frame,
	// create buttons attached to the same listener, etc.) and write a helper
	// method for each. The intention of this demo is to present various
	// features in a sequential way.
	public AdvancedGUI() {
		// create overall window (frame)
		frame = new JFrame("331 is great");
		frame.setSize(400, 300);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		// create some components (buttons)
		button1 = new JButton("Click here to get a 4.0");
		button1.setBackground(Color.RED);
		button1.setFont(new Font("Verdana", Font.BOLD, 18));
		
		button2 = new JButton("Click here to get a 0.0");
		button2.setBackground(Color.YELLOW);
		
		// attach event listener to handle mouse clicks
		MyListener listener = new MyListener();
		button1.addActionListener(listener);
		button2.addActionListener(listener);
		
		// layout manager decides how to position/size the components in the frame
		frame.setLayout(new BorderLayout());
		frame.add(button1, BorderLayout.NORTH);
		frame.add(button2, BorderLayout.SOUTH);
		frame.add(new Button("W"), BorderLayout.WEST);
		frame.add(new Button("I am in the EAST"), BorderLayout.EAST);
		
		// You can also create a panel within the frame that has its own layout
		// and child components
		panel = new JPanel();
		panel.setLayout(new FlowLayout());
		panel.add(new Button("Spiffy button"));
		panel.add(new Button("Spiffier button"));
		panel.add(new Button("Spiffiest button!"));
		frame.add(panel);
		
		// Do this after the frame is all set up
		frame.pack();
		frame.setVisible(true);
	}
	
	// This class handles "action events", aka mouse clicks, in buttons.
	// For anything less trivial than this demo, your ActionListener should have
	// a more descriptive name.
	private class MyListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == button1) {
				button2.setBackground(Color.BLUE);
			} else {
				// event source is button2
				button1.setBackground(Color.BLUE);
			}
		}
	}
}





